/*
* Far Named Folders 2.x
* Copyright (c) 2002-2004 by Victor Derevyanko, RAMMuS Group
* www: http://www.rammus.ru
* e-mail: wingspan@yandex.ru
*/
#pragma once
#include <list>
#include <vector>
#include "settings.h"


namespace kr {class CKernel;}
extern kr::CKernel *g_pK;

namespace kr
{

typedef enum tcommand_flags 
{
	FGC_ENABLED_SHORTCUT = 0x1			//  
	,FGC_ENABLED_LOCAL_DIRECTORY = 0x2	//   (  OPEN)
	,FGC_ENABLED_PARAM = 0x4			//    
	,FGC_ENABLED_CATALOG = 0x10			// 
	,FGC_ENABLED_PREFIX = 0x20			// 
} _tcommand_flags;

typedef enum tcommands_kinds 
{	
	QK_OPEN_SHORTCUT	//cd:
	,QK_INSERT_SHORTCUT	//cd::
	,QK_INSERT_SHORTCUT_TEMPORARY //cd:+
	,QK_INSERT_BOTH				//cd:::
	,QK_INSERT_BOTH_TEMPORARY	//cd:+:
	,QK_DELETE_SHORTCUT	//cD:- 
	,QK_DELETE_CATALOG	//cD:- /
	,QK_OPEN_NETWORK	/*cd:\\*/
	,QK_OPEN_PANEL		//cd:
	,QK_OPEN_BY_PATH	//cd:~ 
	,QK_INSERT_SHORTCUT_IMPLICIT	//cd:: 
	,QK_INSERT_SHORTCUT_TEMPORARY_IMPLICIT	//cd:+ 
	,QK_DELETE_SHORTCUT_IMPLICIT	//cd:-
	,QK_OPEN_ENVIRONMENT_VARIABLE	//cd:%
} _tcommands_kinds;

typedef struct tparsed_command
{
	ULONG flags;//  tcommand_flags -
				//     
				//+    
	tcommands_kinds kind;	// 
	tstring prefix;			// cd  .
	tstring catalog;		// 
	tstring shortcut;		// 
	tstring local_directory;//   
	tstring param;			//   
} _tparsed_command;

typedef struct tshortcut_info
{
	tstring catalog;	//    
	tstring shortcut;	// 
	bool bIsTemporary;	//
} _tshortcut_info;

/*typedef struct thsortcut_value_info
{
	tstring shortcut_value;		// 
	DATE time_creation;			//   
	DATE time_access;			//    
	ULONG number_executions;	//- 
} _tshortcut_value_info;	*/

typedef tstring tcatalog_info;	//   (   )

typedef std::vector<tstring> tcatalogs_list;
typedef std::vector<kr::tshortcut_info> tshortcuts_list;
typedef std::vector<tstring> tdirs_list;
typedef std::vector<tstring> tvalues_list;
typedef std::vector<tstring> tenvvars_list;

class CKernel
{
public:
	CKernel();
	virtual ~CKernel(void);

	nf::CSettings m_S;	

//   
	bool parse_command(tstring const &source,  kr::tparsed_command &cmd);		
	tstring GetFirstPluginPrefix();

//     //
//      
//     
//    
	size_t select_variants_catalogs(TCHAR const *catalog_pattern, tcatalogs_list& list);
	size_t select_variants_shortcuts(tstring shortcut_pattern, tstring catalog, tshortcuts_list& list);	
	size_t select_variants_catalogs_and_shortcuts(TCHAR const *shortcut_pattern, TCHAR const* catalog_pattern, tshortcuts_list& list);
	size_t select_variants_dirs(tstring const &root_dir, tstring const&dir_pattern, tdirs_list& list);
	size_t select_variants_shortcuts_by_path(TCHAR const *catalog_pattern
		, TCHAR const *value_pattern
		, bool bExactCoincidence
		, tshortcuts_list& list);

//  
	bool insert_shortcut(tshortcut_info const&shortcut, tstring value, bool bOverride);		
	bool modify_shortcut(tshortcut_info const&from
		, tshortcut_info const&to, tstring * pnew_value = 0);		//  
	bool delete_shortcut(tshortcut_info const&shortcut);		// 
	bool move_shortcut(tshortcut_info const&shortcut
		, tstring const& new_shortcut_path
		, tshortcut_info &new_shortcut
	);
	bool copy_shortcut(tshortcut_info const&shortcut
		, tstring const& new_shortcut_path
		, tshortcut_info &new_shortcut
	);

//  
	bool insert_catalog(tstring catalog, TCHAR const* Parent = _T(""));		
	bool delete_catalog(tstring const& SourceCatalog)
	{
		return remove_catalog(SourceCatalog, 0, true);
	}
	bool move_catalog(tstring const& SourceCatalog
		, tstring const& TargetCatalog)
	{
		return remove_catalog(SourceCatalog, &TargetCatalog, true);
	}
	bool copy_catalog(tstring const& SourceCatalog
		, tstring const& TargetCatalog)
	{
		return remove_catalog(SourceCatalog, &TargetCatalog, false);
	}

//    
	bool get_value_for_shortcut(tshortcut_info const& sh, tstring& value);
private:
	bool remove_catalog(tstring const& SourceCatalog
		, tstring const* pTargetCatalog
		, bool bDeleteSource);
};

}