/*
* Copyright (c) 2002-2004 by Victor Derevyanko, RAMMuS Group
* www: http://www.rammus.ru
* e-mail: wingspan@yandex.ru
*/
#pragma once
#include "plugin.hpp"
#include <map>
#include <vector>
#include "kernel.h"
#include "regnotify.h"
#include "StatesManager.h"

namespace nf {

class CPanelUpdater;

class CPanel
{
	typedef std::vector<tstring> tvecstr;
	typedef std::vector<PluginPanelItem> tpanelitems;
	typedef std::map<PluginPanelItem*, tpanelitems*> tmap_panelitems;

	tstring m_PanelTitle;				// 
	tstring m_CurrentCatalog;			//    
	
	tvecstr m_ListShortcutsValues;		//    
	tvecstr m_ListShortcutsNames;		//    
	tvecstr m_ListCatalogsNames;		//   
	unsigned int NumberTemporaryShortcuts;		//-   (   m_ListShortcutsNames)

	tstring m_PreviousDir;	//,       
	tmap_panelitems m_find_cash;	//        

	CRegNotify m_RegNotify;
	CStatesManager m_States;
public:
	CPanel(tstring catalog = _T(""));
	~CPanel(void);

	enum {
		FG_SHORTCUTS = 0x1
		,FG_CATALOGS = 0x2
		, FG_ALL = FG_SHORTCUTS | FG_CATALOGS
		, FG_ANY = FG_ALL
	};

	void GetOpenPluginInfo(struct OpenPluginInfo *Info);
	int GetFindData(PluginPanelItem **pPanelItem, int *pItemsNumber, int OpMode);	
	void FreeFindData(struct PluginPanelItem *PanelItem, int ItemsNumber);
	int SetDirectory(const char *Dir, int OpMode);
	int PutFiles(struct PluginPanelItem *PanelItem, int ItemsNumber, int Move, int OpMode);
	int ProcessKey(int Key, unsigned int ControlState);
	int MakeDirectory (char *Name, int OpMode);
	int ProcessEvent(int Event, void *Param);

public:
	void UpdateListItems(DWORD flags = FG_ALL);

private:
	bool CreateCatalog(tstring const& ParentCatalog, tstring &CreatedCatalogName);
	BOOL MoveItems(PanelInfo &pi, bool bCopy = false);
	BOOL CopyItems(PanelInfo &pi) { return MoveItems(pi, true); }
	bool EditShortcut(kr::tshortcut_info const &sh, PanelInfo &pi);
	bool InsertShortcut(PanelInfo &pi);

private:
	tpanelitems m_PanelItems;			//    
//           
// m_PanelItems
	friend CPanelUpdater;

	bool IsSelectedItemIsCatalog(PanelInfo &pi, int nSelectedItem = 0) const;
	kr::tshortcut_info& GetSelectedShortcut(PanelInfo &pi, kr::tshortcut_info& sh, int nSelectedItem = 0);
	tstring GetSelectedCatalog(PanelInfo &pi, int nSelectedItem = 0);
	int go_to_up_folder(int OpMode);
	tstring get_panel_title() const
	{
		return tstring(_T("Named Folders:")) + m_CurrentCatalog;
	}
	void get_selected_shortcut_info(kr::tshortcut_info &sh);
	bool delete_item(PanelInfo &pi, int nSelectedItem = 0);
	tstring get_inactive_panel_current_catalog();
};

};	//fp