/*
* Far Named Folders 2.x
* Copyright (c) 2002-2004 by Victor Derevyanko, RAMMuS Group
* www: http://www.rammus.ru
* e-mail: wingspan@yandex.ru
*/
#include "StdAfx.h"
#include "statesmanager.h"
#include "codec_for_values.h"
#include <shlwapi.h>
using namespace nf;

CStatesManager::CStatesManager(void)
{
}

namespace
{
	void get_state(nf::tshortcut_value_parsed const &p, ULONG &state)
	{	
		if (! p.bValueEnabled) return;
		if (p.ValueType != nf::VAL_TYPE_LOCAL_DIRECTORY) return;

		ULONG n = static_cast<ULONG>(::PathFileExists(p.value.c_str()) 
				? nf::STATE_EXISTS
				: nf::STATE_NOT_FOUND
			);
		state |= 2 << n;
	}
}

tshortcut_state CStatesManager::GetState(tstring const& value)
{
	nf::tshortcut_value_parsed ap;
	nf::tshortcut_value_parsed inap;
	nf::decode_values(value, ap, inap);
	ULONG res = 0;
	get_state(ap, res);
	get_state(inap, res);
	nf::tshortcut_state state = nf::STATE_NO_STATE;
	switch (res)
	{
	case 2 << STATE_EXISTS: state = nf::STATE_EXISTS; break;
	case 2 << STATE_NOT_FOUND: state = nf::STATE_NOT_FOUND; break;
	case (2 << STATE_NOT_FOUND) | (2 << STATE_EXISTS): 
		state = nf::STATE_PARTLY_EXISTS; break;
	};
	return state;
}
