/*
* Far Named Folders 2.x
* Copyright (c) 2002-2004 by Victor Derevyanko, RAMMuS Group
* www: http://www.rammus.ru
* e-mail: wingspan@yandex.ru
*/
#include "StdAfx.h"
#include "codec_for_values.h"

using namespace nf;
namespace 
{
	TCHAR const* DEVCHAR_DEPRECATED = _T("\n");	
		//     
		//  
	TCHAR const* DEVCHAR = _T("|");	
		//     
	TCHAR const* STR_AMP = _T("&");
	TCHAR const* STR_AMP_SCREENED = _T("&");
	
//    
	tstring replace_substring(tstring &s, TCHAR const * sfrom, TCHAR const* sto)
	{
		size_t npos = 0;
		while (true)
		{
			size_t n = s.find(sfrom, npos);
			if (n == tstring::npos) return s;
			s.replace(n
				, sizeof(sfrom)/sizeof(TCHAR)
				, sto);
			npos = n + sizeof(sfrom)/sizeof(TCHAR) + 1;
		}
	}
	inline tstring get_screened(tstring s)
	{		
		return replace_substring(s, STR_AMP, STR_AMP_SCREENED);
	};
//    
	inline tstring get_unscreened(tstring s)
	{
		return replace_substring(s, STR_AMP_SCREENED, STR_AMP);
	}
}

tstring nf::encode_values(TCHAR const* value_first_panel, 
						  TCHAR const* value_second_panel)
{
	if (! lstrlen(value_second_panel)) return get_screened(value_first_panel);
	return get_screened(value_first_panel) 
		+ tstring(DEVCHAR) 
		+ get_screened(value_second_panel);
}

//  
int nf::decode_values(tstring const& value
					  , tshortcut_value_parsed & FirstPanelValue
					  , tshortcut_value_parsed & SecondPanelValue)
{
	size_t n = value.find(DEVCHAR);
	if (n == tstring::npos) n = value.find(DEVCHAR_DEPRECATED);	
		//      2.0 beta 1
	if (n == tstring::npos)
	{
		FirstPanelValue.bValueEnabled = true;
		FirstPanelValue.value = get_unscreened(value);
		FirstPanelValue.ValueType = get_named_folder_type(value);
		SecondPanelValue.bValueEnabled = false;
	} else 
	{
		tstring v2 = get_unscreened(value);
		FirstPanelValue.bValueEnabled = true;
		FirstPanelValue.value.assign(v2.c_str(), 0, n);
		FirstPanelValue.ValueType = get_named_folder_type(FirstPanelValue.value);

		SecondPanelValue.bValueEnabled = true;
		SecondPanelValue.value.assign(v2.c_str(), n+1, v2.size());
		SecondPanelValue.ValueType = get_named_folder_type(SecondPanelValue.value);
	}

	return 0;
}


nf::tshortcutvalue_type nf::get_named_folder_type(tstring const& value)
{	//     
	if (! value.size()) return nf::VAL_TYPE_LOCAL_DIRECTORY;
	if (value.size() > 2)
	{
		switch(value[0]) {
		case _T('\\'):
			if (value[1] == _T('\\')) return nf::VAL_TYPE_NET_DIRECTORY;
			break;
		case _T('%'): 
			return nf::VAL_ENVIRONMENT_VARIABLE;
		}
	};

	tstring::size_type npos = value.find_first_of(_T(':'));
	if (npos != tstring::npos &&  npos > 1) return nf::VAL_TYPE_PLUGIN_DIRECTORY;

	return nf::VAL_TYPE_LOCAL_DIRECTORY;
}