/*
* Far Named Folders 2.x
* Copyright (c) 2002-2004 by Victor Derevyanko, RAMMuS Group
* www: http://www.rammus.ru
* e-mail: wingspan@yandex.ru
*/
#include "StdAfx.h"
#include "strings_utils.h"

void remove_leading_chars(tstring &str, TCHAR ch)
{
	tstring::iterator p = str.begin();
	while (p != str.end())
		if (*p == ch) ++p;
		else break;

	str.erase(str.begin(), p);
}

void remove_trailing_chars(tstring &str, TCHAR ch)
{
	if (! str.size()) return;
	tstring::iterator p = str.end()-1;
	while (p != str.begin())
		if (*p == ch) --p;
		else break;

	str.erase(p+1, str.end());
	if (p == str.begin())
		if (*p == ch)
			str.clear();
}


void add_trailing_char_if_not_exists(tstring &str, TCHAR ch)
{
	if (str.size())
		if (*str.rend() != SLASH_CATS_CHAR) 
			str += SLASH_CATS_CHAR;
}

void add_leading_char_if_not_exists(tstring &str, TCHAR ch)
{
	if (str.size())
		if (*str.begin() != SLASH_CATS_CHAR)
			str.insert(0, SLASH_CATS_CHAR);
}

void divide_path_filename(tstring const &src
						  , tstring &path
						  , tstring &filename
						  , TCHAR SlashChar
						  , bool bRemoveTrailingChar)
{
	path = src;
	if (bRemoveTrailingChar) 
		remove_trailing_chars(path, SLASH_CATS_CHAR);
			
	tstring::size_type npos = path.find_last_of(SLASH_CATS_CHAR);
	if (npos != tstring::npos) 
	{
		filename.assign(path, npos, path.size()-npos);
		path.erase(npos, path.size()-npos);
	} else {
		path.clear();
		filename = src;
	}

	if (filename == _T(".."))
	{
		path += SLASH_CATS_CHAR + filename;
		filename.clear();
	}
}
